.\" Copyright 1993 David Metcalfe (david@prism.demon.co.uk)
.\"
.\" Permission is granted to make and distribute verbatim copies of this
.\" manual provided the copyright notice and this permission notice are
.\" preserved on all copies.
.\"
.\" Permission is granted to copy and distribute modified versions of this
.\" manual under the conditions for verbatim copying, provided that the
.\" entire resulting derived work is distributed under the terms of a
.\" permission notice identical to this one
.\" 
.\" Since the Linux kernel and libraries are constantly changing, this
.\" manual page may be incorrect or out-of-date.  The author(s) assume no
.\" responsibility for errors or omissions, or for damages resulting from
.\" the use of the information contained herein.  The author(s) may not
.\" have taken the same level of care in the production of this manual,
.\" which is licensed free of charge, as they might when working
.\" professionally.
.\" 
.\" Formatted or processed versions of this manual, if unaccompanied by
.\" the source, must acknowledge the copyright and authors of this work.
.\"
.\" References consulted:
.\"     Linux libc source code
.\"     Lewine's _POSIX Programmer's Guide_ (O'Reilly & Associates, 1991)
.\"     386BSD man pages
.\"
.\" Modified Sat Jul 24 19:20:36 1993 by Rik Faith (faith@cs.unc.edu)
.\" Modified Mon May 27 21:37:47 1996 by Martin Schulze (joey@linux.de)
.\"
.TH GETPWNAM 3  "May 27, 1996" "GNU" "Linux Programmer's Manual"
.SH NAME
getpwnam, getpwuid \- get password file entry
.SH SYNOPSIS
.nf
.B #include <pwd.h>
.B #include <sys/types.h>
.sp
.BI "struct passwd *getpwnam(const char * " name );
.sp
.BI "struct passwd *getpwuid(uid_t " uid );
.fi
.SH DESCRIPTION
The \fBgetpwnam()\fP function returns a pointer to a structure containing
the broken out fields of a line from \fI/etc/passwd\fP for the entry that 
matches the user name \fIname\fP.
.PP
The \fBgetpwuid()\fP function returns a pointer to a structure containing
the broken out fields of a line from \fI/etc/passwd\fP for the entry that 
matches the user uid \fIuid\fP.
.PP
The \fIpasswd\fP structure is defined in \fI<pwd.h>\fP as follows:
.sp
.RS
.nf
.ta 8n 16n 32n
struct passwd {
        char    *pw_name;		/* user name */
        char    *pw_passwd;		/* user password */
        uid_t   pw_uid;			/* user id */
        gid_t   pw_gid;			/* group id */
        char    *pw_gecos;      	/* real name */
        char    *pw_dir;  		/* home directory */
        char    *pw_shell;      	/* shell program */
};
.ta
.fi
.RE
.SH "RETURN VALUE"
The \fBgetpwnam()\fP and \fBgetpwuid()\fP functions return the passwd
structure, or NULL if the matching entry is not found or an error occurs.
.SH ERRORS
.TP
.B ENOMEM
Insufficient memory to allocate passwd structure.
.SH FILES
.TP
.I /etc/passwd
password database file
.fi
.SH "CONFORMING TO"
SVID 3, POSIX, BSD 4.3
.SH "SEE ALSO"
.BR fgetpwent "(3), " getpwent "(3), " setpwent "(3), " endpwent (3),
.BR getpw "(3), " putpwent (3),
.BR passwd (5).
